#ifndef _FTPFS_CACHE_H_
#define _FTPFS_CACHE_H_

#define FTP_CACHE_LEN	10
#define FTP_CACHE_HASH	10

struct ftp_dir_entry{
	umode_t		mode;
	char*		name;
	off_t		size;
	nlink_t		nlink;
	unsigned long	blocksize;
	unsigned long	blocks;
};

struct ftp_dirlist_node{
	struct ftp_dirlist_node *prev, *next;
	struct ftp_dir_entry entry;
};

struct ftp_directory{
	struct ftp_dirlist_node *head;
	int			valid;
	time_t			time;
	char			*name;
};

struct ftp_hashlist_node{
	struct ftp_hashlist_node *prev, *next;
	struct ftp_directory	 directory;
};

struct ftp_dir_cache{
	struct ftp_hashlist_node *hash[FTP_CACHE_HASH];
	unsigned len[FTP_CACHE_HASH];
};

int ftp_cache_init();
int ftp_cache_empty();
struct ftp_directory* ftp_cache_get(struct ftp_sb_info*, char*);

#endif